unit uThreadTimer;

interface

uses
  uSimpleThread;

type

  TThreadTimer = class; // ǰ TThreadTimer һ

  TOnThreadTimer = procedure(Sender: TThreadTimer) of object;
  // ˴Ϳ TThreadTimer,д⽫ Sender дΪ TObject;
  // ΪʲôҪд sender ҪΪ˭¼ sender ϿԴ
  // һʹ

  TThreadTimer = Class(TSimpleThread)
  private
    FInterval: Cardinal;
    FOnThreadTimer: TOnThreadTimer;

    procedure CountTimer;
    procedure DoCountTimer;
    procedure SetInterval(val: Cardinal);
    procedure SetOnThreadTimer(val: TOnThreadTimer);

    procedure DoOnThreadTimer; // ѧϰд

  public
    constructor Create(AAllowActiveX: Boolean = false); // AAlowActiveX ڸ˵
    procedure StartThread; override; // ظ StartThread
    property Interval: Cardinal read FInterval write SetInterval default 1000;

    //  default 1000 Ǹ˿ģʵá
    // ʻҪ Create ¼ָ FInterval:=1000;
    // ӻؼ published УֵʾԱ༭

    property OnThreadTimer: TOnThreadTimer read FOnThreadTimer write SetOnThreadTimer;

  End;

implementation

{ TThreadTimer }

procedure TThreadTimer.CountTimer;
begin
  ExeProcInThread(DoCountTimer);
  //  DoCountTimer ߳ȥִ
  //  TSimpleThread ÷
end;

constructor TThreadTimer.Create(AAllowActiveX: Boolean);
begin
  inherited Create(AAllowActiveX);
  FInterval := 1000; // ĬϼʱΪ 1 
end;

procedure TThreadTimer.DoCountTimer;
begin

  if WaitStop then // Ǹһ,ʾ߳Ҫֹͣˡ
    exit;

  SleepExceptStopped(FInterval); // sleep ָʱ,;ӵ˳ָӦ
  // Դ룬ɿһ

  if not WaitStop then
  begin
    DoOnThreadTimer; // ʱ䵽¼
  end;

  CountTimer; // ٴִ߳ DoCountTimer;
  // Ѿƺˣ򵥵صãʵִ߳бֲ̣𡰵ݹ顱

end;

procedure TThreadTimer.DoOnThreadTimer;
begin
  if Assigned(FOnThreadTimer) then
    FOnThreadTimer(Self);
  // дΪһ̣Ɔ£Ϊ˳ɶԣֵõġ
end;

procedure TThreadTimer.StartThread;
begin
  inherited;
  CountTimer; // ʱ
end;

procedure TThreadTimer.SetInterval(val: Cardinal);
begin
  FInterval := val;
end;

procedure TThreadTimer.SetOnThreadTimer(val: TOnThreadTimer);
begin
  FOnThreadTimer := val;
end;

end.
