unit uFrmThreadTimer;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, uThreadTimer, Vcl.StdCtrls;

type
  TFrmThreadTimer = class(TForm)
    memMsg: TMemo;
    btnStartCountTime: TButton;
    btnStopCountTime: TButton;
    procedure btnStartCountTimeClick(Sender: TObject);
    procedure btnStopCountTimeClick(Sender: TObject);

    procedure FormCreate(Sender: TObject); // ڴ¼
    procedure FormDestroy(Sender: TObject); // ͷ¼

  private
    { Private declarations }
    FThreadTimer: TThreadTimer;
    procedure OnThreadTimer(Sender: TThreadTimer);
  public
    { Public declarations }
  end;

var
  FrmThreadTimer: TFrmThreadTimer;

implementation

{$R *.dfm}

procedure TFrmThreadTimer.btnStartCountTimeClick(Sender: TObject);
begin
  FThreadTimer.StartThread; // ߳
end;

procedure TFrmThreadTimer.btnStopCountTimeClick(Sender: TObject);
begin
  FThreadTimer.StopThread; // ֹֹ̣ͣ߳ͣʱ
end;

procedure TFrmThreadTimer.FormCreate(Sender: TObject);
begin
  FThreadTimer := TThreadTimer.Create;
  FThreadTimer.OnThreadTimer := Self.OnThreadTimer; // ָ OnThreadTimer ¼
  FThreadTimer.Interval := 1500; //  1.5 
end;

procedure TFrmThreadTimer.FormDestroy(Sender: TObject);
begin
  FThreadTimer.Free; // ڸƺã˴ֱ free ɣͨԴ
end;

procedure TFrmThreadTimer.OnThreadTimer(Sender: TThreadTimer);
begin
  // Ϊ˹еĴִ߳УҪ vcl  memMsg
  // Ҫдѷ vcl Ĵִ߳
  //  TThread.Queue ÷
  TThread.Synchronize(nil,
    procedure
    begin
      memMsg.Lines.Add('ʱ¼ѷ!')
    end);
end;

end.
